package net.minecraft.src;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import net.minecraft.client.Minecraft;

import org.lwjgl.input.Keyboard;
import org.lwjgl.opengl.GL11;

//TODO Figure out the new spawneranimals

//TODO Sometimes guns don't fire
//TODO Cannon block doesn't like to work in some directions
//TODO Flashbangs still not long enough
//TODO Make sentries one block with different metadata, might suck for textures
//TODO Can make reloadable sentries
//TODO Delay between parachute uses?

//TODO Make oil not last forever
//TODO Flashbang timing hacked, always subtracts 1 now, could be slow for laggy people
//TODO Flashbang ringing ears
//TODO Flashbang make it light up area
//TODO Strings on parachute
//TODO Flashbang should stun mobs
//TODO Muzzle flash with light
//TODO Barbed wire?

//TODO Stop god damn sentry base from rotating
//TODO Grenade launcher
//TODO Need glass shattering particles on shot glass
//TODO getDeathSound for Sentry

//TODO Need to bind sentry to owner... could just say they have to own the area
//TODO Rocket sound on rocket, bullet sound on bullets?
//TODO Make grenades and rocket launcher not damage blocks in flagged zones
//TODO /ally 0 off 1 see online/offline 2 plus see name 3 plus build in areas, admins see all (toggle)
//TODO Render guns so they look held in hand
//TODO EntityBullet offset to the side for all bipeds, not just player
//TODO EntitySoldier check if 1 is good height for bullets and casings

// SDK
public class mod_SdkGuns extends BaseMod
{
    public static final Block blockNuke = (new SdkBlockNuke(110, ModLoader.getUniqueSpriteIndex("/terrain.png"))).setHardness(0.0F).setStepSound(Block.soundGrassFootstep).func_20012_a("nuke");
    public static final Block blockSentry = (new SdkBlockSentry(111, ModLoader.getUniqueSpriteIndex("/terrain.png"))).func_20012_a("sentry");
    public static final Block blockLighter = (new SdkBlockLighter(112, Block.stone.blockIndexInTexture)).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).func_20012_a("lighter");
    public static final Block blockOil = (new SdkBlockOil(113, ModLoader.getUniqueSpriteIndex("/terrain.png"))).setHardness(-1F).func_20012_a("blockOil");
    public static final int blockOilLineIndexInTexture = ModLoader.getUniqueSpriteIndex("/terrain.png");
    public static final Block blockCannon = (new SdkBlockCannon(114, ModLoader.getUniqueSpriteIndex("/terrain.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).func_20012_a("cannon");
	
	public static final Item itemBulletCasing = (new Item(2500)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bulletCasing");
    public static final Item itemBullet9mm = (new SdkItemCustomStackSize(2501, 32)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bullet9mm");
    public static final Item itemBullet357 = (new SdkItemCustomStackSize(2502, 8)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bullet357");
    public static final Item itemBulletShell = (new SdkItemCustomStackSize(2503, 8)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bulletShell");
    public static final Item itemGunAk47 = (new SdkItemGunAk47(2504)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunAk47");
    public static final Item itemGunMp5 = (new SdkItemGunMp5(2505)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunMp5");
    public static final Item itemGunShotgun = (new SdkItemGunShotgun(2506)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunShotgun");
    public static final Item itemGunDeagle = (new SdkItemGunDeagle(2507)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunDeagle");
    public static final Item itemGrenade = (new SdkItemGrenade(2508, 4)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("grenade");
    public static final Item itemMetalParts = (new Item(2514)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("metalParts");
    public static final Item itemBulletRocket = (new SdkItemCustomStackSize(2515, 4)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bulletRocket");
    public static final Item itemGunRocketLauncher = (new SdkItemGunRocketLauncher(2516)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunRocketLauncher");
    public static final Item itemBulletRocketLaser = (new SdkItemCustomStackSize(2517, 4)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bulletRocketLaser");
    public static final Item itemGunRocketLauncherLaser = (new SdkItemGunRocketLauncherLaser(2518)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunRocketLauncherLaser");
    public static final Item itemBullet50Cal = (new SdkItemCustomStackSize(2519, 4)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bullet50Cal");
    public static final Item itemGunSniper = (new SdkItemGunSniper(2520)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunSniper");
    public static final Item itemFlashbang = (new SdkItemFlashbang(2522, 4)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("flashbang");
    public static final Item itemGrenadeSmoke = (new SdkItemGrenadeSmoke(2524, 4)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("grenadeSmoke");
    public static final Item itemBulletCasingShell = (new Item(2525)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("bulletCasingShell");
    public static final Item itemOil = (new SdkItemOil(2526)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("itemOil");
    public static final Item itemGunFlamethrower = (new SdkItemGunFlamethrower(2527)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20011_a("gunFlamethrower");

    // Sentry texture indices
    public static Class[] sentryEntityClasses = { SdkEntitySentryAk47.class, SdkEntitySentryMp5.class, SdkEntitySentryShotgun.class, SdkEntitySentryDeagle.class,
    	SdkEntitySentryRocketLauncher.class, SdkEntitySentryRocketLauncherLaser.class, SdkEntitySentrySniper.class, SdkEntitySentryFlamethrower.class };
    public static int[] sentryTextureIndices = new int[sentryEntityClasses.length];

    // For sounds
    private static boolean soundsAdded = false;
    
    // For multiple textures
    public static final int blockSentrySideIndexInTexture = ModLoader.getUniqueSpriteIndex("/terrain.png");
    public static final int blockLighterTopIndexInTexture = ModLoader.getUniqueSpriteIndex("/terrain.png");
    
    // Instead of in EntityPlayer
    public static Map<EntityPlayer, Integer> reloadTimes = new HashMap<EntityPlayer, Integer>();
    private static final double RECOIL_FIX_FACTOR = 0.1F;
    private static final double MIN_RECOIL_FIX = 0.5F;
    public static double currentRecoilV = 0F;
    public static double currentRecoilH = 0F;
    private static int lastRecoilFixTime = 0;
    public static final float MAX_ZOOM = 1.0F;
    private static final float MIN_ZOOM = 0.125F;
    private static final float ZOOM_INCREMENT = 0.075F;
    private static float zoom = MAX_ZOOM;
    private static int lastZoomTime = 0;
    private static int lastReloadDecrementTime = 0;
    public static Map<EntityPlayer, Integer> flashbangFlashTimes = new HashMap<EntityPlayer, Integer>();
    public static Map<EntityPlayer, Integer> flashbangSoundTimes = new HashMap<EntityPlayer, Integer>();
    private static int lastFlashDecrementTime = 0;
    
    // Minecraft
    public static Minecraft mc = ModLoader.getMinecraftInstance();
    
    // Initialization
    private static boolean initialized = false;
    
    // Properties
    public static boolean guns = true;
    public static boolean sentries = true;
    public static boolean grenades = true;
    public static boolean nuke = true;
    public static float nukeBlastDiameter = 8;
    public static int nukeFuse = 80;
    public static boolean oil = true;
    public static boolean lighter = true;
    public static boolean cannon = true;
    public static boolean ammoRestrictions = false;
    public static boolean hardcore = false;
    public static int zoomKey = Keyboard.KEY_Z;
    
    // For zoom
    public static boolean zoomKeyDown = false;
    public static boolean zoomEnabled = false;
    
    static
    {
    	loadProperties();
        setHardcore();
        getSentryTextureIndices();
    }
    
    private static void loadProperties()
    {
    	Properties properties = new Properties();
    	try
    	{
    		properties.load(new FileInputStream("mod_SdkGuns.properties"));
    		String property;
    		
    		property = properties.getProperty("guns");
    		guns = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("grenades");
    		grenades = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("nuke");
    		nuke = property.trim().equalsIgnoreCase("true");

    		property = properties.getProperty("nukeBlastDiameter");
    		nukeBlastDiameter = Float.parseFloat(property.trim());

    		property = properties.getProperty("nukeFuse");
    		nukeFuse = Integer.parseInt(property.trim());

    		property = properties.getProperty("nuke");
    		nuke = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("oil");
    		oil = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("lighter");
    		lighter = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("cannon");
    		cannon = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentries");
    		sentries = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoRestrictions");
    		ammoRestrictions = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("hardcore");
    		hardcore = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("zoomKey");
    		int tempZoomKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempZoomKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding zoom key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			zoomKey = tempZoomKey;
    		}
        }
        catch(Exception e)
        {
        	System.out.println("Error loading properties.");
			e.printStackTrace();
        }
    }

	private static void setHardcore()
    {
    	if(hardcore)
    	{
	    	try
			{
	    		Field[] fields = EnumCreatureType.class.getDeclaredFields();
				for(int i = 0; i < fields.length; i++)
					if(fields[i].getType() == int.class)
					{
						fields[i].setAccessible(true);
						
						Field modifiersField = Field.class.getDeclaredField("modifiers");
					    modifiersField.setAccessible(true);
					    modifiersField.setInt(fields[i], fields[i].getModifiers() & ~Modifier.FINAL);
						
					    fields[i].set(EnumCreatureType.monster, 1000);
					}
			}
			catch (Exception e)
			{
				System.out.println("Error setting hardcore mode.");
				e.printStackTrace();
			}
    	}
    }
    
    private static void getSentryTextureIndices()
    {
		for(int i = 0; i < sentryTextureIndices.length; i++)
		{
			sentryTextureIndices[i] = ModLoader.getUniqueSpriteIndex("/terrain.png");
		}
	}
	
	public mod_SdkGuns()
	{
		ModLoader.RegisterBlock(blockNuke);
		ModLoader.RegisterBlock(blockSentry);
		ModLoader.RegisterBlock(blockLighter);
		ModLoader.RegisterBlock(blockOil);
		ModLoader.RegisterBlock(blockCannon);
		
		ModLoader.AddName(blockNuke, "Nuke");
		ModLoader.AddName(blockSentry, "Sentry");
		ModLoader.AddName(blockLighter, "Lighter");
		ModLoader.AddName(blockOil, "Oil");
		ModLoader.AddName(blockCannon, "Cannon");

		Block.fire.setBurnRate(blockNuke.blockID, 15, 100);
		Block.fire.setBurnRate(blockOil.blockID, 30, 60);
	    
		ModLoader.AddName(itemBulletCasing, "Bullet Casing");
		ModLoader.AddName(itemBullet9mm, "Automatic Bullet");
		ModLoader.AddName(itemBullet357, "Pistol Bullet");
		ModLoader.AddName(itemBulletShell, "Shotgun Bullet");
		ModLoader.AddName(itemGunAk47, "AK47");
		ModLoader.AddName(itemGunMp5, "MP5");
		ModLoader.AddName(itemGunShotgun, "Shotgun");
		ModLoader.AddName(itemGunDeagle, "Desert Eagle");
		ModLoader.AddName(itemGrenade, "Grenade");
		ModLoader.AddName(itemMetalParts, "Metal Parts");
		ModLoader.AddName(itemBulletRocket, "Rocket");
		ModLoader.AddName(itemGunRocketLauncher, "Rocket Launcher");
		ModLoader.AddName(itemBulletRocketLaser, "Laser-Guided Rocket");
		ModLoader.AddName(itemGunRocketLauncherLaser, "Laser-Guided Rocket Launcher");
		ModLoader.AddName(itemBullet50Cal, "Rifle Bullet");
		ModLoader.AddName(itemGunSniper, "Sniper Rifle");
		ModLoader.AddName(itemFlashbang, "Flashbang");
		ModLoader.AddName(itemGrenadeSmoke, "Smoke Grenade");
		ModLoader.AddName(itemBulletCasingShell, "Shell Casing");
		ModLoader.AddName(itemOil, "Oil");
		ModLoader.AddName(itemGunFlamethrower, "Flamethrower");
	    
	    // For GuiIngame showing ammo amount
	    itemBullet9mm.maxDamage = 0;
	    itemBullet357.maxDamage = 0;
	    itemBulletShell.maxDamage = 0;
	    itemBulletRocket.maxDamage = 0;
	    itemBulletRocketLaser.maxDamage = 0;
	    itemBullet50Cal.maxDamage = 0;
		
		ModLoader.RegisterEntityID(SdkEntityBullet.class, "Bullet", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletShell.class, "Shell", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasing.class, "Casing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasingShell.class, "ShellCasing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenade.class, "Grenade", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityNukePrimed.class, "Nuke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryAk47.class, "SentryAk47", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryDeagle.class, "SentryDeagle", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryMp5.class, "SentryMp5", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncher.class, "SentryRocketLauncher", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncherLaser.class, "SentryRocketLauncherLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryShotgun.class, "SentryShotgun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySniper.class, "SentrySniper", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocket.class, "Rocket", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocketLaser.class, "RocketLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityFlashbang.class, "Flashbang", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSmoke.class, "GrenadeSmoke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletFlame.class, "Flame", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryFlamethrower.class, "SentryFlamethrower", ModLoader.getUniqueEntityId());
	}
	
	@Override
	public String Version()
	{
		return "1";
	}
    
    public static void initialize()
    {
    	if(!initialized && mc.theWorld != null)
    	{
		    if(!mc.theWorld.multiplayerWorld && !ammoRestrictions)
		    {
		    	itemBullet9mm.maxStackSize = 32;
		    	itemBullet357.maxStackSize = 32;
		    	itemBulletShell.maxStackSize = 32;
		    	itemGrenade.maxStackSize = 64;
		    	itemBulletRocket.maxStackSize = 32;
		    	itemBulletRocketLaser.maxStackSize = 32;
		    	itemBullet50Cal.maxStackSize = 32;
		    	itemFlashbang.maxStackSize = 64;
		    	itemGrenadeSmoke.maxStackSize = 64;
		    }
			
			initialized = true;
    	}
    }
	
	@Override
	public void OSDHook(Minecraft minecraft, boolean menuOpen)
	{
		addSounds(minecraft);
		tick(menuOpen);
	}

	@Override
    public void AddRecipes(CraftingManager craftingmanager)
    {
		if(nuke)
		{
			craftingmanager.addRecipe(new ItemStack(blockNuke, 1), new Object[] {
	            "X#X", "#X#", "X#X", Character.valueOf('X'), Block.tnt, Character.valueOf('#'), Item.redstone
	        });
		}
		
		if(guns)
		{
			craftingmanager.addRecipe(new ItemStack(itemGunAk47, 1), new Object[] {
	            "X  ", "XX ", " X#", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
	        });
			craftingmanager.addRecipe(new ItemStack(itemGunMp5, 1), new Object[] {
	        	"X  ", "XX ", " XX", Character.valueOf('X'), itemMetalParts
	        });
			craftingmanager.addRecipe(new ItemStack(itemGunDeagle, 1), new Object[] {
	        	"XXX", "  X", Character.valueOf('X'), itemMetalParts
	        });
			craftingmanager.addRecipe(new ItemStack(itemGunShotgun, 1), new Object[] {
	        	"X  ", "#X ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
	        });
			craftingmanager.addRecipe(new ItemStack(Item.ingotIron, 1), new Object[] {
	        	"XX", "XX", Character.valueOf('X'), itemBulletCasing
	        });
			craftingmanager.addRecipe(new ItemStack(itemBullet9mm, 4), new Object[] {
	            "X", "#", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
	        });
			craftingmanager.addRecipe(new ItemStack(itemBullet357, 4), new Object[] {
	            "X ", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
	        });
			craftingmanager.addRecipe(new ItemStack(itemBulletShell, 4), new Object[] {
	            "X ", "#Y", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder, Character.valueOf('Y'), Item.paper
	        });
			craftingmanager.addRecipe(new ItemStack(itemGunRocketLauncher, 1), new Object[] {
	            "XXX", "XX ", Character.valueOf('X'), itemMetalParts
	        });
			craftingmanager.addRecipe(new ItemStack(itemGunRocketLauncherLaser, 1), new Object[] {
	            "#XY", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), itemMetalParts, Character.valueOf('Y'), itemGunRocketLauncher
	        });
			craftingmanager.addRecipe(new ItemStack(itemBulletRocket, 4), new Object[] {
	            "###", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
	        });
			craftingmanager.addRecipe(new ItemStack(itemBulletRocketLaser, 4), new Object[] {
	            "#Y#", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron,  Character.valueOf('Y'), Item.redstone
	        });
			craftingmanager.addRecipe(new ItemStack(itemGunSniper, 1), new Object[] {
	            "X  ", "XX#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
	        });
			craftingmanager.addRecipe(new ItemStack(itemBullet50Cal, 4), new Object[] {
	            "XX", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
	        });
			craftingmanager.addRecipe(new ItemStack(Item.paper, 1), new Object[] {
	        	"XX", "XX", Character.valueOf('X'), itemBulletCasingShell
	        });
			craftingmanager.addRecipe(new ItemStack(itemGunFlamethrower, 1), new Object[] {
				"X# ", "XX ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.flintAndSteel
	        });
		}
		
		if(guns || sentries)
		{
			craftingmanager.addRecipe(new ItemStack(itemMetalParts, 1), new Object[] {
				"##", "##", Character.valueOf('#'), Item.ingotIron
			});
			craftingmanager.addRecipe(new ItemStack(Item.ingotIron, 4), new Object[] {
				"#", Character.valueOf('#'), itemMetalParts
			});
		}
		
		if(grenades)
		{
			craftingmanager.addRecipe(new ItemStack(itemGrenade, 4), new Object[] {
	            "X#X", "#X#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
	        });
			craftingmanager.addRecipe(new ItemStack(itemFlashbang, 4), new Object[] {
	            "X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.lightStoneDust
	        });
			craftingmanager.addRecipe(new ItemStack(itemGrenadeSmoke, 4), new Object[] {
				"X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.flint
	        });
		}
		
		if(sentries)
		{
			if(guns)
			{
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 0), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunAk47, Character.valueOf('X'), itemMetalParts
		        });
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 1), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunMp5, Character.valueOf('X'), itemMetalParts
		        });
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 2), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunShotgun, Character.valueOf('X'), itemMetalParts
		        });
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 3), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunDeagle, Character.valueOf('X'), itemMetalParts
		        });
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 4), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncher, Character.valueOf('X'), itemMetalParts
		        });
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 5), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncherLaser, Character.valueOf('X'), itemMetalParts
		        });
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 6), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSniper, Character.valueOf('X'), itemMetalParts
		        });
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 7), new Object[] {
		        	" # ", " X ", "X X", Character.valueOf('#'), itemGunFlamethrower, Character.valueOf('X'), itemMetalParts
		        });
			}
			else
			{
				craftingmanager.addRecipe(new ItemStack(blockSentry, 1, 0), new Object[] {
		        	" X ", " X ", "X X", Character.valueOf('X'), itemMetalParts
		        });
			}
		}
		
		if(lighter)
		{
			craftingmanager.addRecipe(new ItemStack(blockLighter, 1), new Object[] {
	        	"XXX", "X#X", "XXX", Character.valueOf('X'), Block.cobblestone, Character.valueOf('#'), Item.flintAndSteel
	        });
		}
		
		if(oil)
		{
			craftingmanager.addRecipe(new ItemStack(itemOil, 1), new Object[] {
	        	" X ", "X#X", " X ", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.bucketWater
	        });
		}
		
		if(cannon)
		{
			craftingmanager.addRecipe(new ItemStack(blockCannon, 1), new Object[] {
	        	"XXX", "X#X", "XXX", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.redstone
	        });
		}
    }

	@Override
    public void AddRenderer(Map map)
    {
    	map.put(SdkEntityBullet.class, new SdkRenderBullet());
		map.put(SdkEntityBulletShell.class, new SdkRenderBulletShell());
		map.put(SdkEntityBulletCasing.class, new SdkRenderBulletCasing());
		map.put(SdkEntityBulletCasingShell.class, new SdkRenderBulletCasingShell());
		map.put(SdkEntityNukePrimed.class, new SdkRenderNukePrimed());
		map.put(SdkEntityGrenade.class, new SdkRenderGrenade());
		map.put(SdkEntitySentry.class, new SdkRenderSentry());
		map.put(SdkEntityBulletRocket.class, new SdkRenderBulletRocket());
		map.put(SdkEntityBulletRocketLaser.class, new SdkRenderBulletRocketLaser());
		map.put(SdkEntityFlashbang.class, new SdkRenderFlashbang());
		map.put(SdkEntityGrenadeSmoke.class, new SdkRenderGrenadeSmoke());
		map.put(SdkEntityBulletFlame.class, new SdkRenderBulletFlame());
    }

	@Override
    public void RegisterTextureOverrides()
    {
    	ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png", blockNuke.blockIndexInTexture);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentry.png", blockSentrySideIndexInTexture);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryAk47.png", sentryTextureIndices[0]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryMp5.png", sentryTextureIndices[1]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryShotgun.png", sentryTextureIndices[2]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryDeagle.png", sentryTextureIndices[3]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryRocketLauncher.png", sentryTextureIndices[4]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryRocketLauncherLaser.png", sentryTextureIndices[5]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentrySniper.png", sentryTextureIndices[6]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockLighter.png", blockLighterTopIndexInTexture);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockOilJunction.png", blockOil.blockIndexInTexture);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockOilLine.png", blockOilLineIndexInTexture);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryFlamethrower.png", sentryTextureIndices[7]);
    	ModLoader.addOverride("/terrain.png", "/sdk/blockCannon.png", blockCannon.blockIndexInTexture);
    	
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasing.png", itemBulletCasing.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet9mm.png", itemBullet9mm.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet357.png", itemBullet357.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletShell.png", itemBulletShell.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunAk47.png", itemGunAk47.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunMp5.png", itemGunMp5.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunShotgun.png", itemGunShotgun.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunDeagle.png", itemGunDeagle.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenade.png", itemGrenade.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemMetalParts.png", itemMetalParts.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocket.png", itemBulletRocket.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncher.png", itemGunRocketLauncher.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocketLaser.png", itemBulletRocketLaser.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncherLaser.png", itemGunRocketLauncherLaser.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet50Cal.png", itemBullet50Cal.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSniper.png", itemGunSniper.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemFlashbang.png", itemFlashbang.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSmoke.png", itemGrenadeSmoke.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasingShell.png", itemBulletCasingShell.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemOil.png", itemOil.iconIndex);
        ModLoader.addOverride("/gui/items.png", "/sdk/itemGunFlamethrower.png", itemGunFlamethrower.iconIndex);
    }
	
	@Override
	public void AddNetClientHandlerEntities(Map<Integer, Class> map)
	{
		map.put(100, SdkEntityBullet.class);
		map.put(101, SdkEntityBulletShell.class);
		map.put(102, SdkEntityBulletCasing.class);
		map.put(103, SdkEntityBulletCasingShell.class);
		map.put(104, SdkEntityGrenade.class);
		map.put(105, SdkEntityNukePrimed.class);
		map.put(106, SdkEntitySentryAk47.class);
		map.put(107, SdkEntitySentryDeagle.class);
		map.put(108, SdkEntitySentryMp5.class);
		map.put(109, SdkEntitySentryRocketLauncher.class);
		map.put(110, SdkEntitySentryRocketLauncherLaser.class);
		map.put(111, SdkEntitySentryShotgun.class);
		map.put(112, SdkEntitySentrySniper.class);
		map.put(113, SdkEntityBulletRocket.class);
		map.put(114, SdkEntityBulletRocketLaser.class);
		map.put(115, SdkEntityFlashbang.class);
		map.put(116, SdkEntityGrenadeSmoke.class);
		map.put(117, SdkEntityBulletFlame.class);
		map.put(118, SdkEntitySentryFlamethrower.class);
	}
    
	public static boolean handleMouse0(boolean buttonDown)
	{
		return false;
	}

	public static boolean handleMouse1(boolean buttonDown)
	{
		return false;
	}

	public static boolean overrideMouseCheck0(float f1)
	{
		return false;
	}

	public static boolean overrideMouseCheck1(int sinceLastUse)
	{
		if(mc.thePlayer != null && mc.thePlayer.inventory != null)
		{
			ItemStack itemStack = mc.thePlayer.inventory.getCurrentItem();
			
			if(itemStack != null
					&& itemStack.getItem() instanceof SdkItemCustomUseDelay
					&& sinceLastUse >= ((SdkItemCustomUseDelay)itemStack.getItem()).useDelay)
				return true;
		}
		
		return false;
	}
	
    private static void addSounds(Minecraft minecraft)
    {
		if(!soundsAdded)
		{
			soundsAdded = true;
			
			try
			{
				File resourcesFolder = new File(minecraft.mcDataDir, "resources/");
				
		        String[] soundTypes =  { "sound", "music", "streaming" };
		        for(int i = 0; i < soundTypes.length; i++)
		        {
		            File[] modSoundFiles = new File(resourcesFolder, "sdk/" + soundTypes[i]).listFiles();
		            for(int j = 0; j < modSoundFiles.length; j++)
		            	minecraft.installResource(soundTypes[i] + "/" + modSoundFiles[j].getName(), modSoundFiles[j]);
		        }
			}
			catch (Exception e)
			{
				System.out.println("Error adding sounds.");
				e.printStackTrace();
			}
		}
	}

	public static void tick(boolean menuOpen)
	{
		if(!(Item.itemsList[blockSentry.blockID] instanceof SdkItemSentry))
		{
	        Item.itemsList[blockSentry.blockID] = null;
	        Item.itemsList[blockSentry.blockID] = (new SdkItemSentry(blockSentry.blockID - 256)).func_20011_a("sentry");
		}
		
		int sinceLastRecoilFix = mc.ticksRan - lastRecoilFixTime;
		
		if(sinceLastRecoilFix > 0)
		{
			double recoilFixV = 0, lastRecoilV = currentRecoilV;
			if(!menuOpen && mc.thePlayer != null && currentRecoilV > 0D)
			{
				recoilFixV = Math.min(Math.max(currentRecoilV * RECOIL_FIX_FACTOR, MIN_RECOIL_FIX), currentRecoilV);
				currentRecoilV -= recoilFixV;
				mc.thePlayer.rotationPitch += recoilFixV;
			}
			
			if(!menuOpen && mc.thePlayer != null && Math.abs(currentRecoilH) > 0D)
			{
				double recoilFixH;
				if(currentRecoilH > 0D)
					recoilFixH = Math.min(Math.max(currentRecoilH * RECOIL_FIX_FACTOR / 2, MIN_RECOIL_FIX / 2), currentRecoilH);
				else
					recoilFixH = Math.max(Math.min(currentRecoilH * RECOIL_FIX_FACTOR / 2, -MIN_RECOIL_FIX / 2), currentRecoilH);
				
				if(recoilFixV != 0)
				{
					double synchedRecoilFix = recoilFixV / lastRecoilV * currentRecoilH;
					
					if(currentRecoilH > 0D)
						recoilFixH = Math.min(synchedRecoilFix, recoilFixH);
					else
						recoilFixH = Math.max(synchedRecoilFix, recoilFixH);
				}
				
				currentRecoilH -= recoilFixH;
				mc.thePlayer.rotationYaw -= recoilFixH;
			}
			
			lastRecoilFixTime = mc.ticksRan;
		}
		
		int sinceLastReloadDecrement = mc.ticksRan - lastReloadDecrementTime;
		
		if(sinceLastReloadDecrement > 0)
		{
			Iterator<Map.Entry<EntityPlayer,Integer>> it = reloadTimes.entrySet().iterator();
	    	while (it.hasNext()) {
	    	    Map.Entry<EntityPlayer,Integer> entry = it.next();
	    	    
	    	    int n = entry.getValue() - sinceLastReloadDecrement;
	    	    
	    	    if (n <= 0)
	    	        it.remove();
	    	    else
	    	    	entry.setValue(n);
	    	}
	    	
	    	lastReloadDecrementTime = mc.ticksRan;
		}
		
		if (!menuOpen)
		{
            if(!Keyboard.isKeyDown(zoomKey))
            {
            	if(zoomKeyDown)
            		handleZoomKey();
            }
            
            zoomKeyDown = Keyboard.isKeyDown(zoomKey);
        }
	}
	
	public static void handleZoomKey()
	{
		zoomEnabled = !zoomEnabled;
	}

	public static float getZoom()
	{
		boolean zoomedIn = false;
		if(mc.gameSettings != null && mc.thePlayer != null && mc.thePlayer.inventory != null)
		{
			ItemStack itemStack = mc.thePlayer.inventory.getCurrentItem();
			
			if(itemStack != null && itemStack.getItem() != itemGunSniper)
				zoomEnabled = false;
			
			if(itemStack != null && itemStack.getItem() == itemGunSniper && !mc.gameSettings.thirdPersonView && zoomEnabled)
				zoomedIn = true;
		}
		
		int sinceLastZoom = mc.ticksRan - lastZoomTime;
		
		if(sinceLastZoom > 0)
			if(zoomedIn && zoom > MIN_ZOOM)
			{
				if(zoom == MAX_ZOOM)
					zoom -= ZOOM_INCREMENT;
				else
					zoom = Math.max(MIN_ZOOM, zoom - ZOOM_INCREMENT * sinceLastZoom);
				
				lastZoomTime = mc.ticksRan;
			}
			else if(!zoomedIn && zoom < MAX_ZOOM)
			{
				if(zoom == MIN_ZOOM)
					zoom += ZOOM_INCREMENT;
				else
					zoom = Math.min(MAX_ZOOM, zoom + ZOOM_INCREMENT * sinceLastZoom);
				
				lastZoomTime = mc.ticksRan;
			}
		
		return zoom;
	}
	
	public static int getNumberInFirstStackInInventory(InventoryPlayer inventory, int i)
    {
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == i)
            {
            	if(inventory.mainInventory[j].getItem().maxDamage > 0)
            	{
            		return inventory.mainInventory[j].getItem().maxDamage - getItemDamage(inventory.mainInventory[j]) + 1;
            	}
            	else
            	{
            		return inventory.mainInventory[j].stackSize;
            	}
            }
        }

        return -1;
    }
	
	public static int getNumberInFirstStackInHotbar(InventoryPlayer inventory, int i)
    {
        for(int j = 0; j < 9; j++)
        {
            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == i)
            {
                return inventory.mainInventory[j].stackSize;
            }
        }

        return -1;
    }
	
	public static float getFlash()
	{
		int sinceLastFlashDecrement = mc.ticksRan - lastFlashDecrementTime;
		
		if(sinceLastFlashDecrement > 0)
		{
			if(mc.currentScreen == null)
			{
				Iterator<Map.Entry<EntityPlayer,Integer>> it = flashbangFlashTimes.entrySet().iterator();
		    	while (it.hasNext()) {
		    	    Map.Entry<EntityPlayer,Integer> entry = it.next();
		    	    
		    	    int n = entry.getValue() - 1;
		    	    
		    	    if (n <= 0)
		    	        it.remove();
		    	    else
		    	    	entry.setValue(n);
		    	}
		    	
		    	if(flashbangFlashTimes.containsKey(mc.thePlayer))
		    	{
		    		return (float)flashbangFlashTimes.get(mc.thePlayer) / SdkEntityFlashbang.MAX_FLASH_TIME;
		    	}
			}
	    	
	    	lastFlashDecrementTime = mc.ticksRan;
		}
		
		return 0F;
	}
	
	public static int getItemDamage(ItemStack itemStack)
	{
		try
		{
			return (Integer)ModLoader.getPrivateValue(ItemStack.class, itemStack, "d");
		}
		catch (NoSuchFieldException ex)
		{
			System.out.println("Error getting item damage.");
			ex.printStackTrace();
		}
		
		return 0;
	}
	
	public static void setItemDamage(ItemStack itemStack, int itemDamage)
	{
		try
		{
			ModLoader.setPrivateValue(ItemStack.class, itemStack, "d", itemDamage);
		}
		catch (NoSuchFieldException ex)
		{
			System.out.println("Error setting item damage.");
			ex.printStackTrace();
		}
	}
	
	@Override
    public boolean RenderBlocks(RenderBlocks renderBlocks, Block block, int i,
			int j, int k, int l, IBlockAccess blockAccess,
			int overrideBlockTexture, boolean renderAllFaces)
	{
		try
		{
	        if(l == 22)
	        {
	            return renderBlockOil(block, i, j, k, blockAccess, overrideBlockTexture);
	        }
		}
		catch (Exception e)
		{
			System.out.println("Error rendering mods.");
			e.printStackTrace();
		}
		
		return false;
	}
	
	public static boolean renderBlockOil(Block block, int i, int j, int k, IBlockAccess blockAccess, int overrideBlockTexture)
    {
        Tessellator tessellator = Tessellator.instance;
        int l = block.getBlockTextureFromSideAndMetadata(1, blockAccess.getBlockMetadata(i, j, k));
        if(overrideBlockTexture >= 0)
        {
            l = overrideBlockTexture;
        }
        float f = block.getBlockBrightness(blockAccess, i, j, k);
        tessellator.setColorOpaque_F(f, f, f);
        int i1 = (l & 0xf) << 4;
        int j1 = l & 0xf0;
        double d = (float)i1 / 256F;
        double d1 = ((float)i1 + 15.99F) / 256F;
        double d2 = (float)j1 / 256F;
        double d3 = ((float)j1 + 15.99F) / 256F;
        float f1 = 0.0F;
        float f2 = 0.03125F;
        boolean flag = blockAccess.getBlockId(i - 1, j, k) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j - 1, k) == blockOil.blockID;
        boolean flag1 = blockAccess.getBlockId(i + 1, j, k) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j - 1, k) == blockOil.blockID;
        boolean flag2 = blockAccess.getBlockId(i, j, k - 1) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j - 1, k - 1) == blockOil.blockID;
        boolean flag3 = blockAccess.getBlockId(i, j, k + 1) == blockOil.blockID || !blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j - 1, k + 1) == blockOil.blockID;
        if(!blockAccess.isBlockOpaqueCube(i, j + 1, k))
        {
            if(blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j + 1, k) == blockOil.blockID)
            {
                flag = true;
            }
            if(blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j + 1, k) == blockOil.blockID)
            {
                flag1 = true;
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j + 1, k - 1) == blockOil.blockID)
            {
                flag2 = true;
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j + 1, k + 1) == blockOil.blockID)
            {
                flag3 = true;
            }
        }
        float f3 = 0.3125F;
        float f4 = i + 0;
        float f5 = i + 1;
        float f6 = k + 0;
        float f7 = k + 1;
        byte byte0 = 0;
        if((flag || flag1) && !flag2 && !flag3)
        {
            byte0 = 1;
        }
        if((flag2 || flag3) && !flag1 && !flag)
        {
            byte0 = 2;
        }
        if(byte0 != 0)
        {
            d = (float)(i1 + 16) / 256F;
            d1 = ((float)(i1 + 16) + 15.99F) / 256F;
            d2 = (float)j1 / 256F;
            d3 = ((float)j1 + 15.99F) / 256F;
        }
        if(byte0 == 0)
        {
            if(flag1 || flag2 || flag3 || flag)
            {
                if(!flag)
                {
                    f4 += f3;
                }
                if(!flag)
                {
                    d += f3 / 16F;
                }
                if(!flag1)
                {
                    f5 -= f3;
                }
                if(!flag1)
                {
                    d1 -= f3 / 16F;
                }
                if(!flag2)
                {
                    f6 += f3;
                }
                if(!flag2)
                {
                    d2 += f3 / 16F;
                }
                if(!flag3)
                {
                    f7 -= f3;
                }
                if(!flag3)
                {
                    d3 -= f3 / 16F;
                }
            }
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d1, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d, d3);
        }
        if(byte0 == 1)
        {
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d1, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d, d3);
        }
        if(byte0 == 2)
        {
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f7 + f1, d1, d3);
            tessellator.addVertexWithUV(f5 + f1, (float)j + f2, f6 - f1, d, d3);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f6 - f1, d, d2);
            tessellator.addVertexWithUV(f4 - f1, (float)j + f2, f7 + f1, d1, d2);
        }
        d = (float)(i1 + 16) / 256F;
        d1 = ((float)(i1 + 16) + 15.99F) / 256F;
        d2 = (float)j1 / 256F;
        d3 = ((float)j1 + 15.99F) / 256F;
        if(!blockAccess.isBlockOpaqueCube(i, j + 1, k))
        {
            if(blockAccess.isBlockOpaqueCube(i - 1, j, k) && blockAccess.getBlockId(i - 1, j + 1, k) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 1) + f1, (float)(k + 1) + f1, d1, d2);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 0) - f1, (float)(k + 1) + f1, d, d2);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 0) - f1, (float)(k + 0) - f1, d, d3);
                tessellator.addVertexWithUV((float)i + f2, (float)(j + 1) + f1, (float)(k + 0) - f1, d1, d3);
            }
            if(blockAccess.isBlockOpaqueCube(i + 1, j, k) && blockAccess.getBlockId(i + 1, j + 1, k) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 0) - f1, (float)(k + 1) + f1, d, d3);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 1) + f1, (float)(k + 1) + f1, d1, d3);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 1) + f1, (float)(k + 0) - f1, d1, d2);
                tessellator.addVertexWithUV((float)(i + 1) - f2, (float)(j + 0) - f1, (float)(k + 0) - f1, d, d2);
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k - 1) && blockAccess.getBlockId(i, j + 1, k - 1) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 0) - f1, (float)k + f2, d, d3);
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 1) + f1, (float)k + f2, d1, d3);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 1) + f1, (float)k + f2, d1, d2);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 0) - f1, (float)k + f2, d, d2);
            }
            if(blockAccess.isBlockOpaqueCube(i, j, k + 1) && blockAccess.getBlockId(i, j + 1, k + 1) == blockOil.blockID)
            {
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 1) + f1, (float)(k + 1) - f2, d1, d2);
                tessellator.addVertexWithUV((float)(i + 1) + f1, (float)(j + 0) - f1, (float)(k + 1) - f2, d, d2);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 0) - f1, (float)(k + 1) - f2, d, d3);
                tessellator.addVertexWithUV((float)(i + 0) - f1, (float)(j + 1) + f1, (float)(k + 1) - f2, d1, d3);
            }
        }
        return true;
    }
}
